#############################
#
# COPYRIGHT (c) 2007 shagon
# COMPILER:PythonWin
# DEBUG ON Series 60 C++ SDKs
# TESTED ON MY NOKIA6670
# DATE:Sep 21th,2007
#
##############################
# -*- coding:utf-8 -*- 
import e32
import appuifw
from graphics import*
import random

def detec_exit():
    if appuifw.query('确认退出\n取消返回'.decode('utf8'),'query'):
        appuifw.app.set_exit()
    else:
        background()
        
appuifw.app.exit_key_handler=detec_exit

def background():
    appuifw.app.screen='large'
    appuifw.app.title='屏幕检测'.decode("utf-8")
    appuifw.app.body = appuifw.Text('\n\n\n     屏幕检测(shagon出品) \n－－－－－－－－－－－－－\n左软键-菜单     右软建-退出\n－－－－－－－－－－－－－ \n1) 检测屏幕显色能力\n2) 检测屏幕有无坏点'.decode("utf-8"))
    appuifw.app.menu =[
                    (
                      ('检测模式'.decode("utf-8")),
                      (
                          ('三原色检测'.decode("utf-8"),three_detec),
                          ('静态色检测'.decode("utf-8"),normal_detec),
                          ('动态色检测'.decode("utf-8"),loop_detec)
                                                               )),   
                      ('关于作者'.decode("utf-8"),about_info),
                      ('退出软件'.decode("utf-8"),detec_exit)
                                                                                       ]
    

def about_info():
    appuifw.note('杜俊(shagon)作品 \n www.cnpda.com.cn \n 2007.09.21'.decode("utf-8"), "info")
    
def color_detec(thecolor):
    appuifw.app.screen = 'full'
    img=Image.new((176,208))
    img.clear(thecolor)              
    def handle_redraw(rect):
        canvas.blit(img)
    canvas =appuifw.Canvas(event_callback=None, redraw_callback=handle_redraw)
    appuifw.app.body = canvas
  
def three_detec():
    color_choice=['红色'.decode("utf-8"),'绿色'.decode("utf-8"),'蓝色'.decode("utf-8")]
    index=appuifw.selection_list(choices=color_choice , search_field=1)
    if index==0: color_detec(16711680)
    elif index==1: color_detec(65280)
    else: color_detec(255)
            
def normal_detec():
    if appuifw.query('将随机出现\n一种颜色\n请检查屏幕'.decode('utf8'),'query'):
        randcolor=random.randint(0,16777215)
        color_detec(randcolor)
    else:
        background()
        
def loop_detec():
    if appuifw.query('将随机出现\n十种颜色\n请检查屏幕'.decode('utf8'),'query'):
        for x in range(10):
            randcolor=random.randint(0,16777215)
            color_detec(randcolor)
            e32.ao_sleep(2)
        background()
    else:
        background()
        
app_lock=e32.Ao_lock()
background()
app_lock.wait()